var canvas;
var cntx;
var fVal;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
} 

function initialiseGUI(){
    chkDirection=new chkbox(cntx,chkDirectionLEFT,chkDirectionTOP,"Αντιστροφή κατεύθυνσης",false);
    
    HScrParam1=new slider(HScrParam1LEFT,HScrParam1TOP,HScrParam1WIDTH,HScrParam1HEIGHT,HScrParam1Min,HScrParam1Max,HScrParam1Min,HScrParam1Visible,HScrParam1ScaleDigital,[],HScrParam1ViewComparative,cntx,false,valuePosMovable);
    HScrParam2=new slider(HScrParam2LEFT,HScrParam2TOP,HScrParam2WIDTH,HScrParam2HEIGHT,HScrParam2Min,HScrParam2Max,HScrParam2Min,HScrParam2Visible,HScrParam2ScaleDigital,[],HScrParam2ViewComparative,cntx,false,valuePosMovable);
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    $("#algorithmSlctr").val("blank");
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Εικόνες
    drawIntroImage();
    drawLogoImage();
    //Κουμπιά
    if(introStep<5){
    	$("#divAlgorithmSelector").hide();
    	drawButtonNext();
    }
    else{
        $("#divAlgorithmSelector").show();
    }
    if(introStep>1){
    	drawButtonBack();
    }
    if(SelectedAlgorithm>0){
        HScrParam1.render();
        HScrParam2.render();
        if(SelectedAlgorithm>1 && chkDirectionEnabled){
            chkDirection.render();
        }
    }

    
	var promptYCoord=BottomPanelTop+25;
    if(introStep>=5){
        if(introStep>5){
            cntx.strokeStyle="rgb(0,0,255)";
            cnvsWrite("",fontSize,"Arial",HScrParam1LEFT+HScrParam1WIDTH+15,HScrParam1TOP+13,"Επαναλήψεις");
            cnvsWrite("",fontSize,"Arial",HScrParam1LEFT+HScrParam1WIDTH+15,HScrParam2TOP+13,"Αρχικές Τιμές");
        }
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Διάλεξε έναν Αλγόριθμο από τη λίστα για να δεις τις εντολές και το αποτέλεσμά τους.");
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Άλλαξε τα πλήθη των Επαναλήψεων για να κάνεις το σχήμα συνθετότερο ή απλούστερο.");
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+40,"Τροποποίησε τις Αρχικές Τιμές ή/και τις Συνθήκες για να μεταβάλλεις το αποτέλεσμα.");
        if(SelectedAlgorithm>0){
            ShowCode();
            if(SelectedAlgorithm>1) {
                if(SelectedAlgorithm==4 && PolygonSides==3) {
                    cntx.strokeStyle="rgb(180,180,180)";
                }
                else {
                    cntx.strokeStyle="rgb(0,0,255)";
                }
            }
            DrawSelectedAlgorithm();
        }
    }
}

function drawIntroImage(){
	Intro=document.getElementById("img"+introStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    if(fontName!=""){
    	cntx.font=fontSize+"px "+fontName;
    }
    if(clr!=""){
    	cntx.fillStyle=clr;
    }
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(introStep>5){
	    if(HScrParam1.markerHover(mx,my)){
	        HScrParam1.markerGrabbed=true;
	        HScrParam1.mouseXOffset=mx-HScrParam1.markerLeft;
	    }
	    else if(HScrParam2.markerHover(mx,my)){
	        HScrParam2.markerGrabbed=true;
	        HScrParam2.mouseXOffset=mx-HScrParam2.markerLeft;
	    }
	}
}

function handleMouseMove(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
    }
    
    canvas.style.cursor="default";
    if(introStep>5){
        if(HScrParam1.markerGrabbed){
            HScrParam1.setMarkerPosition(mx-HScrParam1.mouseXOffset);
            canvas.style.cursor="pointer";
            adjustmentValueChanged(HScrParam1Indx);
        }
        else if(HScrParam2.markerGrabbed){
            HScrParam2.setMarkerPosition(mx-HScrParam2.mouseXOffset);
            canvas.style.cursor="pointer";
            adjustmentValueChanged(HScrParam2Indx);
        }
        else if(HScrParam1.markerHover(mx,my) || HScrParam2.markerHover(mx,my)){
            canvas.style.cursor="pointer";
        }
        if(chkDirection.hover(mx,my)){
            canvas.style.cursor="pointer";
        }
    }

    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if (mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<5) {
        introStep++;
    }
    if (mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1) {
        if(introStep>=5){
            introStep=4;
        }
        else{
            introStep--;
        }
    }
    
    if(introStep>5){
        HScrParam1.markerGrabbed=false;
        HScrParam2.markerGrabbed=false;
    	if(chkDirection.hover(mx,my)){
    	    chkDirection.toggleValue();
    	    setDrawingDirection();
    	}
    }
    drawBasicScreen();
}

function selectAlgorithm(){
    console.log("new");
    SelectedAlgorithm=$("#algorithmSlctr").prop("selectedIndex");
    SimulationStep=-1;
    InitialiseAlgorithm();
    if (SelectedAlgorithm==0){
        introStep=5;
    }
    else {
        introStep=52;
    }
    drawBasicScreen();
}

function setDrawingDirection(){
    if(chkDirection.value){
        Direction=1;
    }
    else{
        Direction=0;
    }
    drawBasicScreen();
}

function InitialiseAlgorithm(){
    if (SelectedAlgorithm==1){
        HScrParam1.setMarkerValue(1);
        NoOfCircles=1;
        HScrParam2.setMarkerValue(HScrParam2.max-1);
        AngleDenom=HScrParam2.markerValue;
    }
    else if (SelectedAlgorithm==2 || SelectedAlgorithm==3){
        HScrParam1.setMarkerValue(1);
        n=HScrParam1.markerValue;
        HScrParam2.setMarkerValue(1);
        tt=HScrParam2.markerValue;
        chkDirection.caption="Αντιστροφή Κατεύθυνσης";
        chkDirection.vaue=false;
        chkDirectionEnabled=true;
    }
    else if (SelectedAlgorithm==4){
        HScrParam1.min=3;
        HScrParam1.setMarkerValue(3);
        HScrParam2.setMarkerValue(HScrParam2.max);
        chkDirection.caption="Σχεδίαση Διαγωνίων";
        chkDirection.value=false;
        chkDirectionEnabled=false;
    }
}

function renderAlgorithmControls(){
    HScrParam1.render();
    HScrParam2.render();
    if(SelectedAlgorithm>=2){
        chkDirection.render();
    }
}

function ShowCode(){
    var XScr=20,YScr=TopPanelHeight+90,YCode=BottomPanelTop-45;

    cntx.strokeStyle="rgb(0,0,255)";
    if (SelectedAlgorithm==1){
        var Angle=Math.PI/AngleDenom;
        var XN=CardioidSize;
        var YN=0,temp;
        temp=parseInt(XN*Math.cos(Angle)-YN*Math.sin(Angle));
        YN=parseInt(XN*Math.sin(Angle)+YN*Math.cos(Angle));
        XN=temp;
        var radius=parseInt(Math.sqrt(Math.pow((XN-CardioidSize),2)+Math.pow(YN,2)));
        cnvsWrite("",14,"Arial",XScr,YScr,"X = "+XN);
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"Y = "+YN);
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"R = "+radius);
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"ΕΠΑΝΑΛΑΒΕ "+NoOfCircles+" [");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  Κύκλος(Χ , Υ , R)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  Κύκλος(Χ , -Υ , R)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  ΥπολόγισεΝέο(Χ , Υ , R)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"]");
        cnvsWrite("",14,"Arial",XScr,YCode,"...for(i=0;i<NoOfCircles;i++)");
        cnvsWrite("",14,"Arial",XScr,YCode+20,"temp=XN*cos(Angle);");
        cnvsWrite("",14,"Arial",XScr,YCode+30,"...");
    }
    else if(SelectedAlgorithm==2 || SelectedAlgorithm==3){
        var LineTab="";
        if(SelectedAlgorithm==3){
            LineTab="      ";
            cnvsWrite("",14,"Arial",XScr,YScr,"ΕΠΑΝΑΛΑΒΕ 11 [");
            YScr=YScr+20;
            cnvsWrite("",14,"Arial",XScr,YScr,"   ΕΠΑΝΑΛΑΒΕ 7 [");
            YScr=YScr+20;
        }
        var Angle=""+parseFloat(parseInt(100*tt*(180.0/(4.0*n))))/100;
        if(SelectedAlgorithm==2){
            cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"πλ = "+SquareSideBig);
        }
        else{
            cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"πλ = "+SquareSideSmall);
        }
        YScr=YScr+20;
        if(chkDirection.value && SelectedAlgorithm==2){
            cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"γων = -"+Angle);
        }
        else{
            cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"γων = "+Angle);
        }
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"ΕΠΑΝΑΛΑΒΕ "+n+" [");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"  Τετράγωνο(πλ , γων)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"  ΥπολόγισεΝέο(πλ , γων)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"]");
        if(SelectedAlgorithm==3 && chkDirection.value){
            YScr=YScr+20;
            cnvsWrite("",14,"Arial",XScr,YScr,LineTab+"γων = -γων");
        }
        if(SelectedAlgorithm==3){
            YScr=YScr+20;
            cnvsWrite("",14,"Arial",XScr,YScr,"   ]");
            YScr=YScr+20;
            cnvsWrite("",14,"Arial",XScr,YScr,"]");
        }
        if(SelectedAlgorithm==2){
            cnvsWrite("",14,"Arial",XScr,YCode,"... drawLine(PrevX,PrevY,X[j],Y[j]);");
            cnvsWrite("",14,"Arial",XScr,YCode+20,"YD[j]=smu*Y[j]+rmu*Y[nj];");
        }
        else{
            cnvsWrite("",14,"Arial",XScr,YCode,"... if(YD[j]<yCoord) YD[j]=yCoord;");
            cnvsWrite("",14,"Arial",XScr,YCode+20,"if(XD[j]>radius) YD[j+1]=r;");
        }
        cnvsWrite("",14,"Arial",XScr,YCode+30,"...");
    }
    else if(SelectedAlgorithm==4){
        if(chkDirection.value){
            cnvsWrite("",14,"Arial",XScr,YScr,"διαγ = 1");
        }
        else{
            cnvsWrite("",14,"Arial",XScr,YScr,"διαγ = 0");
        }
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"Κλάσμα = "+Part);
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"ΕΠΑΝΑΛΑΒΕ "+PolygonSides+" [");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  Γραμμή(Χ1 , Υ1 , Χ2 , Υ2 , Κλάσμα)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  ΑΝ διαγ = 1 [");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"    ΣχεδίασεΔιαγωνίους");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  ]");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  Χ1 = Χ2");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  Υ1 = Υ2");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"  ΥπολόγισεΝέο(Χ2 , Υ2)");
        YScr=YScr+20;
        cnvsWrite("",14,"Arial",XScr,YScr,"]");
        cnvsWrite("",14,"Arial",XScr,YCode,"... for(i=0;i<PolygonSides;i++){");
        cnvsWrite("",14,"Arial",XScr,YCode+20,"x_coord[i]=radius*cos(dTheta);");
        cnvsWrite("",14,"Arial",XScr,YCode+30,"...");
    }
}

function DrawSelectedAlgorithm(){
    if(SelectedAlgorithm==1){
        DrawCardioid();
    }
    else if(SelectedAlgorithm==2){
        DrawSecondAlgorithm();
    }
    else if(SelectedAlgorithm==3){
        DrawThirdAlgorithm();
    }
    else if(SelectedAlgorithm==4){
        DrawPolygon();
    }
}

function DrawCardioid(){
    var XN,YN,i;
    var radius,dX,dY,temp;
    var Angle;
    dX=2*width/3;
    dY=height/2;
    cntx.strokeStyle="rgb(200,200,200)";
    cntx.beginPath();
    cntx.moveTo(dX-2*CardioidSize,dY);
    cntx.lineTo(dX+2*CardioidSize,dY);
    
    cntx.moveTo(dX,dY-2*CardioidSize);
    cntx.lineTo(dX,dY+2*CardioidSize);
    cntx.stroke();
    
    cntx.strokeStyle="rgb(0,0,255)";
    Angle=Math.PI/AngleDenom;
    XN=CardioidSize;
    YN=0;
    for(i=0;i<NoOfCircles;i++){
        temp=parseInt(XN*Math.cos(Angle)-YN*Math.sin(Angle));
        YN=parseInt(XN*Math.sin(Angle)+YN*Math.cos(Angle));
        XN=temp;
        radius=parseInt(Math.sqrt(Math.pow((XN-CardioidSize),2)+Math.pow(YN,2)));
        cntx.beginPath();
        cntx.arc(dX+XN,dY+YN,radius,0,2*Math.PI);
        cntx.stroke(); 
        
        cntx.beginPath();
        cntx.arc(dX+XN,dY-YN,radius,0,2*Math.PI);
        cntx.stroke(); 
    }
}

function DrawSecondAlgorithm(){
    var Size=SquareSideBig;
    var lft=(2*width/3-Size)/2+width/3-10;
    var tp=(height-Size)/2+5;
    DrawSquare(lft,tp,Size,Direction);
}

function DrawThirdAlgorithm(){
    var dir=0,SqTop=TopPanelHeight+120;
    var SqLeft,i,j;
    for(i=1;i<8;i++){
        SqLeft=360;
        for(j=1;j<12;j++){
            DrawSquare(SqLeft,SqTop,SquareSideSmall,dir);
            SqLeft=SqLeft+SquareSideSmall;
            if(chkDirection.value) dir=1-dir;
        }
        SqTop=SqTop+SquareSideSmall;
    }
}

function DrawSquare(xCoord,yCoord,Side,dir){
    var smu,rmu;
    var i,j,nj;
    var PrevX,PrevY;
    var X=[0,0,0,0];
    var Y=[0,0,0,0];
    var XD=[0,0,0,0];
    var YD=[0,0,0,0];
    smu=Math.tan(tt*(Math.PI/(4*n)))/(Math.tan(tt*(Math.PI/(4*n)))+1);
    rmu=1-smu;
    X[0]=xCoord+Side;
    Y[0]=yCoord+Side;
    X[1]=xCoord+Side;
    Y[1]=yCoord;
    X[2]=xCoord;
    Y[2]=yCoord;
    X[3]=xCoord;
    Y[3]=yCoord+Side;
    for(i=0;i<n;i++){
        PrevX=X[0];
        PrevY=Y[0];
        for(j=0;j<4;j++){
            nj=(j+1) % 4;
            cntx.beginPath();
            cntx.moveTo(PrevX,PrevY);
            cntx.lineTo(X[j],Y[j]);
            cntx.stroke();
            PrevX=X[j];
            PrevY=Y[j];
            if(dir==0) {
                XD[j]=parseInt(rmu*X[j]+smu*X[nj]);
            }
            else{
                XD[j]=parseInt(smu*X[j]+rmu*X[nj]);
            }
            if(XD[j]<xCoord) XD[j]=xCoord;
            if(XD[j]>xCoord+Side) XD[j]=xCoord+Side;
            if(dir==0) {
                YD[j]=parseInt(rmu*Y[j]+smu*Y[nj]);
            }
            else{
                YD[j]=parseInt(smu*Y[j]+rmu*Y[nj]);
            }
            if(YD[j]<yCoord) YD[j]=yCoord;
            if(YD[j]>yCoord+Side) YD[j]=yCoord+Side;
        }
        cntx.beginPath();
        cntx.moveTo(PrevX,PrevY);
        cntx.lineTo(X[0],Y[0]);
        cntx.stroke();
        for(j=0;j<4;j++){
            X[j]=XD[j];
            Y[j]=YD[j];
        }
    }
}

function DrawPolygon(){
    var i,j,radius,centerX,centerY;
    var Xleft,Ytop,Xright,Ybottom;
    var dTheta;
    radius=100;
    centerX=2*width/3;
    centerY=height/2+5;
    Xleft=parseInt(centerX-Part*radius);
    Ytop=parseInt(centerY-Part*radius);
    Xright=parseInt(centerX+Part*radius);
    Ybottom=parseInt(centerY+Part*radius);
    //Σχεδίαση περιγεγραμμένου κύκλου
    if(Part>=1){
        cntx.strokeStyle="rgb(120,120,120)";
        cntx.beginPath();
        cntx.arc(centerX,centerY,radius,0,2*Math.PI);
        cntx.stroke(); 
    }
    //Σχεδίαση Κόκκινου Πλαισίου
    cntx.strokeStyle="rgb(255,0,0)";
    cntx.beginPath();
    cntx.rect(Xleft,Ytop,parseInt(2*radius*Part),parseInt(2*radius*Part));
    cntx.stroke();
    //Επαναφορά χρώματος σχεδίασης
    cntx.strokeStyle="rgb(0,0,255)";
    dTheta=2*Math.PI/PolygonSides;
    for(i=0;i<PolygonSides;i++){
        x_coord[i]=parseInt(centerX+radius*Math.cos((i-1)*dTheta));
        y_coord[i]=parseInt(centerY+radius*Math.sin((i-1)*dTheta));
    }
    if(chkDirection.value){
        for(i=0;i<PolygonSides-1;i++){
            for(j=i+1;j<PolygonSides;j++){
                if(Part==1){
                    cntx.beginPath();
                    cntx.moveTo(x_coord[i],y_coord[i]);
                    cntx.lineTo(x_coord[j],y_coord[j]);
                    cntx.stroke();
                }
                else {
                    ClipLine(x_coord[i],y_coord[i],x_coord[j],y_coord[j],Xleft,Ytop,Xright,Ybottom);
                }
            }
        }
    }
    else{
        for(i=0;i<PolygonSides;i++){
            j=(i+1) % PolygonSides;
            if(Part==1){
                cntx.beginPath();
                cntx.moveTo(x_coord[i],y_coord[i]);
                cntx.lineTo(x_coord[j],y_coord[j]);
                cntx.stroke();
            }
            else {
                ClipLine(x_coord[i],y_coord[i],x_coord[j],y_coord[j],Xleft,Ytop,Xright,Ybottom);
            }
        }
    }
}

function ClipLine(X1,Y1,X2,Y2,Xleft,Ytop,Xright,Ybottom){
    var XX,aux_X1=0,aux_X2=0,aux_Y1=0,aux_Y2=0;
    var a,b;
    var LineOk;
    
    if(Out(X1,X2,Xleft,Xright) || Out(Y1,Y2,Ytop,Ybottom)) {
        LineOk=false;
    }
    else{
        LineOk=true;
        if(X1==X2){
            aux_X1=X1;
            aux_X2=X1;
            aux_Y1=Math.min(Math.max(Y1,Ytop),Ybottom);
            aux_Y2=Math.min(Math.max(Y2,Ytop),Ybottom);
        }
        else {
            a=parseFloat(Y2-Y1)/parseFloat(X2-X1);
            b=Y2-a*X2;
            if(a!=0) {
                XX=Math.max(Math.min(X1,Xright),Xleft);
                aux_X1=CheckLineX(a,b,XX,Ytop,Ybottom);
                aux_Y1=CheckLineY(a,b,XX,Ytop,Ybottom);
                XX=Math.max(Math.min(X2,Xright),Xleft);
                aux_X2=CheckLineX(a,b,XX,Ytop,Ybottom);
                aux_Y2=CheckLineY(a,b,XX,Ytop,Ybottom);
            }
            else{
                aux_X1=Math.min(Math.max(X1,Xleft),Xright);
                aux_X2=Math.min(Math.max(X2,Xleft),Xright);
                aux_Y1=Y1;
                aux_Y2=Y1;
            }
        }
    }
    if(LineOk && (aux_X1!=aux_X2 || aux_Y1!=aux_Y2)){
        cntx.beginPath();
        cntx.moveTo(aux_X1,aux_Y1);
        cntx.lineTo(aux_X2,aux_Y2);
        cntx.stroke();
    }
}

function CheckLineX(a,b,XX,Ytop,Ybottom){
    var aux_X,YY;
    YY=parseInt(a*XX+b);
    if(Ytop<=YY && YY<=Ybottom){
        aux_X=XX;
    }
    else{
        if(YY<Ytop){
            aux_X=parseInt((Ytop-b)/a);
        }
        else{
            aux_X=parseInt((Ybottom-b)/a);
        }
    }
    return aux_X;
}

function CheckLineY(a,b,XX,Ytop,Ybottom){
    var aux_Y,YY;
    YY=parseInt(a*XX+b);
    if(Ytop<=YY && YY<=Ybottom){
        aux_Y=YY;
    }
    else{
        if(YY<Ytop) {
            aux_Y=Ytop;
        }
        else{
            aux_Y=Ybottom;
        }
    }
    return aux_Y;
}

function Out(A1,A2,Lim1,Lim2){
    if((A1<=Lim1 && A2<=Lim1) || (A1>=Lim2 && A2>=Lim2)){
        return true;
    }
    else{
        return false;
    }
}

function adjustmentValueChanged(indx){
    if(indx==HScrParam1Indx){
        if(SelectedAlgorithm==1){
            NoOfCircles=HScrParam1.markerValue;
        }
        else if(SelectedAlgorithm==2 || SelectedAlgorithm==3){
            n=HScrParam1.markerValue;
        }
        else if(SelectedAlgorithm==4){
            PolygonSides=Math.max(HScrParam1.markerValue,3);
            if(PolygonSides>3){
                chkDirectionEnabled=true;
            }
            else {
                chkDirection.value=false;
                chkDirectionEnabled=false;
            }
        }
    }
    else if(indx==HScrParam2Indx){
        if(SelectedAlgorithm==1){
            AngleDenom=HScrParam2.markerValue;
        }
        else if(SelectedAlgorithm==2 || SelectedAlgorithm==3){
            tt=HScrParam2.markerValue;
        }
        else if(SelectedAlgorithm==4){
            Part=parseFloat(HScrParam2.markerValue)/parseFloat(HScrParam2.max-1);
        }
    }
    drawBasicScreen();
}